"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.presenceListClients = exports.mailerSend = exports.dataHistoryDelete = exports.dataHistoryRead = exports.dataHistoryCreateBatch = exports.updateUserCredentials = exports.updateUser = exports.updateThingCredentials = exports.updateProfile = exports.updateOwnPassword = exports.updateConfiguration = exports.removeRoleFromThing = exports.removeChildFromAsset = exports.readUser = exports.readRole = exports.readProfile = exports.readConfiguration = exports.readChannelType = exports.readChannel = exports.deleteConfiguration = exports.createConfiguration = exports.addRoleToThing = exports.addConfigurationToEntity = exports.addChildToAsset = exports.removeRuleFromAsset = exports.addRuleToAsset = exports.deleteRule = exports.updateRule = exports.readRule = exports.createRule = exports.createRole = exports.removeRoleFromUser = exports.addRoleToUser = exports.deleteUser = exports.createUser = exports.deleteChannel = exports.updateChannel = exports.createChannel = exports.setChannelType = exports.deleteChannelType = exports.updateChannelType = exports.createChannelType = exports.setThingType = exports.deleteThing = exports.updateThing = exports.readThing = exports.createThing = exports.removeChannelFromAsset = exports.addChannelToAsset = exports.setAssetType = exports.readAssetType = exports.createAssetType = exports.deleteAsset = exports.updateAsset = exports.readAsset = exports.createAsset = void 0;

var _com = require("./com");

var namedReq = function namedReq(id) {
  for (var _len = arguments.length, rest = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    rest[_key - 1] = arguments[_key];
  }

  var fn = _com.req.apply(void 0, [id].concat(rest));

  fn.prototype.toString = function () {
    return "".concat(id);
  };

  return fn;
}; // ________________________________________________________
//  conf


var createAsset = namedReq('conf/createAsset'); // export const createAsset = namedReq('conf/createAsset');

exports.createAsset = createAsset;
var readAsset = namedReq('conf/readAsset');
exports.readAsset = readAsset;
var updateAsset = namedReq('conf/updateAsset');
exports.updateAsset = updateAsset;
var deleteAsset = namedReq('conf/deleteAsset');
exports.deleteAsset = deleteAsset;
var createAssetType = namedReq('conf/createAssetType');
exports.createAssetType = createAssetType;
var readAssetType = namedReq('conf/readAssetType');
exports.readAssetType = readAssetType;
var setAssetType = namedReq('conf/setAssetType');
exports.setAssetType = setAssetType;
var addChannelToAsset = namedReq('conf/addChannelToAsset');
exports.addChannelToAsset = addChannelToAsset;
var removeChannelFromAsset = namedReq('conf/removeChannelFromAsset');
exports.removeChannelFromAsset = removeChannelFromAsset;
var createThing = namedReq('conf/createThing');
exports.createThing = createThing;
var readThing = namedReq('conf/readThing');
exports.readThing = readThing;
var updateThing = namedReq('conf/updateThing');
exports.updateThing = updateThing;
var deleteThing = namedReq('conf/deleteThing');
exports.deleteThing = deleteThing;
var setThingType = namedReq('conf/setThingType');
exports.setThingType = setThingType;
var createChannelType = namedReq('conf/createChannelType');
exports.createChannelType = createChannelType;
var updateChannelType = namedReq('conf/updateChannelType');
exports.updateChannelType = updateChannelType;
var deleteChannelType = namedReq('conf/deleteChannelType');
exports.deleteChannelType = deleteChannelType;
var setChannelType = namedReq('conf/setChannelType');
exports.setChannelType = setChannelType;
var createChannel = namedReq('conf/createChannel');
exports.createChannel = createChannel;
var updateChannel = namedReq('conf/updateChannel');
exports.updateChannel = updateChannel;
var deleteChannel = namedReq('conf/deleteChannel');
exports.deleteChannel = deleteChannel;
var createUser = namedReq('conf/createUser');
exports.createUser = createUser;
var deleteUser = namedReq('conf/deleteUser');
exports.deleteUser = deleteUser;
var addRoleToUser = namedReq('conf/addRoleToUser');
exports.addRoleToUser = addRoleToUser;
var removeRoleFromUser = namedReq('conf/removeRoleFromUser');
exports.removeRoleFromUser = removeRoleFromUser;
var createRole = namedReq('conf/createRole');
exports.createRole = createRole;
var createRule = namedReq('conf/createRule');
exports.createRule = createRule;
var readRule = namedReq('conf/readRule');
exports.readRule = readRule;
var updateRule = namedReq('conf/updateRule');
exports.updateRule = updateRule;
var deleteRule = namedReq('conf/deleteRule');
exports.deleteRule = deleteRule;
var addRuleToAsset = namedReq('conf/addRuleToAsset');
exports.addRuleToAsset = addRuleToAsset;
var removeRuleFromAsset = namedReq('conf/removeRuleFromAsset');
/**
 * Adds assets as children to an asset.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Array<String>} args.rids The record ids of the assets to add children to.
 * @param {Array<String>} args.children The record ids of the assets to set as children to the asset.
 * @returns {void}
 */

exports.removeRuleFromAsset = removeRuleFromAsset;
var addChildToAsset = namedReq('conf/addChildToAsset');
/**
 * Adds a configuration to an entity
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Array<String>} args.rids The record ids of the entities to add configurations to.
 * @param {Array<String>} args.configurations The record ids of the configurations to add to the entities.
 * @returns {void}
 */

exports.addChildToAsset = addChildToAsset;
var addConfigurationToEntity = namedReq('conf/addConfigurationToEntity');
/**
 * Adds roles to things.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Array<String>} args.rids The record ids of the things to add roles to.
 * @param {Array<String>} args.roles The record ids of the roles to add.
 * @returns {Number} The number of added roles.
 */

exports.addConfigurationToEntity = addConfigurationToEntity;
var addRoleToThing = namedReq('conf/addRoleToThing');
/**
 * Creates a new configuration.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {String} args.id The id to set for the configuration.
 * @param {Object} args.properties The properties to apply to the configuration.
 * @returns {Object} The created configuration record.
 */

exports.addRoleToThing = addRoleToThing;
var createConfiguration = namedReq('conf/createConfiguration');
/**
 * Deletes configurations in the configuration.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Array<String>} args.rids The record ids to delete, use [] to target all records.
 * @param {Array} args.filter The filter to apply for the delete operation.
 * @returns {Number} The number of deleted records.
 */

exports.createConfiguration = createConfiguration;
var deleteConfiguration = namedReq('conf/deleteConfiguration');
/**
 * Reads channels from the configuration.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Array<String>} args.rids The record ids to read, use [] to target all records.
 * @param {Array} args.filter The filter to apply for the read operation.
 * @param {Array<String>} args.projection The properties to include in the returned record(s).
 * @param {Number} args.limit The maximum number of records to read.
 * @param {Number} args.skip The number of records to skip.
 * @param {Array<String>} args.orderBy The properties to order the records by, Append " desc" for descending order, default is ascending.
 * @param {Array<String>} args.types The record ids of the channel types to read channels from.
 * @returns {Array} An array of the records returned by the read operation.
 */

exports.deleteConfiguration = deleteConfiguration;
var readChannel = namedReq('conf/readChannel');
/**
 * Reads channel types from the configuration.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Array<String>} args.rids The record ids to read, use [] to target all records.
 * @param {Array} args.filter The filter to apply for the read operation.
 * @param {Array<String>} args.projection The properties to include in the returned record(s).
 * @param {Number} args.limit The maximum number of records to read.
 * @param {Number} args.skip The number of records to skip.
 * @param {Array<String>} args.orderBy The properties to order the records by, Append " desc" for descending order, default is ascending.
 * @returns {Array} An array of the records returned by the read operation.
 */

exports.readChannel = readChannel;
var readChannelType = namedReq('conf/readChannelType');
/**
 * Reads configurations from the configuration.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Array<String>} args.rids The record ids to read, use [] to target all records.
 * @param {Array} args.filter The filter to apply for the read operation.
 * @param {Array<String>} args.projection The properties to include in the returned record(s).
 * @param {Number} args.limit The maximum number of records to read.
 * @param {Number} args.skip The number of records to skip.
 * @param {Array<String>} args.orderBy The properties to order the records by, Append " desc" for descending order, default is ascending.
 * @param {Array<String>} args.entities The record ids of the entities to read configurations for.
 * @returns {Array} An array of the records returned by the read operation.
 */

exports.readChannelType = readChannelType;
var readConfiguration = namedReq('conf/readConfiguration');
/**
 * Returns the identity record of the namedRequesting client.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Array<String>} args.projection The properties to include in the returned record(s).
 * @returns {object}
 */

exports.readConfiguration = readConfiguration;
var readProfile = namedReq('conf/readProfile');
/**
 * Reads roles from the configuration.'
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Array<String>} args.rids The record ids to read, use [] to target all records.
 * @param {Array} args.filter The filter to apply for the read operation.
 * @param {Array<String>} args.projection The properties to include in the returned record(s).
 * @param {Number} args.limit The maximum number of records to read.
 * @param {Number} args.skip The number of records to skip.
 * @param {Array<String>} args.orderBy The properties to order the records by, Append " desc" for descending order, default is ascending.
 * @returns {Array} An array of the records returned by the read operation.
 */

exports.readProfile = readProfile;
var readRole = namedReq('conf/readRole');
/**
 * Reads users from the configuration.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Array<String>} args.rids The record ids to read, use [] to target all records.
 * @param {Array} args.filter The filter to apply for the read operation.
 * @param {Array<String>} args.projection The properties to include in the returned record(s).
 * @param {Number} args.limit The maximum number of records to read.
 * @param {Number} args.skip The number of records to skip.
 * @param {Array<String>} args.orderBy The properties to order the records by, Append " desc" for descending order, default is ascending.
 * @returns {Array} An array of the records returned by the read operation.
 */

exports.readRole = readRole;
var readUser = namedReq('conf/readUser');
/**
 * Removes children assets from a parent asset.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Array<String>} args.rids The record ids of the assets to remove children from.
 * @param {Array<String>} args.children  	The record ids of the children assets to remove from the asset.
 * @returns {void}
 */

exports.readUser = readUser;
var removeChildFromAsset = namedReq('conf/removeChildFromAsset');
/**
 * Removes roles from things.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Array<String>} args.rids The record ids of the things to remove roles from.
 * @param {Array<String>} args.roles The record ids of the roles to remove.
 * @returns {Number} The number of removed roles.
 */

exports.removeChildFromAsset = removeChildFromAsset;
var removeRoleFromThing = namedReq('conf/removeRoleFromThing');
/**
 * Updates configurations in the configuration.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Array<String>} args.rids The record ids to update, use [] to target all records.
 * @param {Object} args.properties The properties to apply to the configurations.
 * @param {Array<String>} args.remove The properties to remove from the record.
 * @param {Array} args.filter The filter to apply for the update operation.
 * @param {Number} args.limit The maximum number of records to update.
 * @param {String} args.mode "shallow"
 * @returns {Number} The number of updated records.
 */

exports.removeRoleFromThing = removeRoleFromThing;
var updateConfiguration = namedReq('conf/updateConfiguration');
/**
 * Updates the namedRequesters own password.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {String} args.oldPassword The current password of the namedRequesting client.
 * @param {String} args.newPassword The new password to set for the namedRequesting client.
 * @param {Boolean} args.oldNonHashed Set to true if oldPassword is sent as clear text (not recommended).
 * @param {Boolean} args.newNonHashed Set to true if newPassword is sent as clear text (not recommended).
 * @returns {void}
 */

exports.updateConfiguration = updateConfiguration;
var updateOwnPassword = namedReq('conf/updateOwnPassword');
/**
 * Updates the identity record of the namedRequesting client.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {Object} args.properties The properties to apply to the identity.
 * @returns {void}
 */

exports.updateOwnPassword = updateOwnPassword;
var updateProfile = namedReq('conf/updateProfile');
/**
 * Updates the credentials for the specified thing
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {String} args.rid
 * @param {String} args.id The id to set for the thing.
 * @param {String} args.password The password to set for the thing sha256 hasshed or in clear text if nonHashed is true.
 * @param {Boolean} args.nonHashed Set to true if password is sent as clear text (not recommended).
 * @returns {void}
 */

exports.updateProfile = updateProfile;
var updateThingCredentials = namedReq('conf/updateThingCredentials');
/**
 * Updates the credentials for the specified thing.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {String} args.rid The record id for the thing.
 * @param {String} args.id The id to set for the thing.
 * @param {String} args.password The password to set for the thing sha256 hasshed or in clear text if nonHashed is true.
 * @param {Boolean} args.nonHashed  	Set to true if password is sent as clear text (not recommended).
 * @returns {void}
 */

exports.updateThingCredentials = updateThingCredentials;
var updateUser = namedReq('conf/updateUser');
/**
 * Updates the credentials for the specified user.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {String} args.rid
 * @param {String} args.id The id to set for the user.
 * @param {String} args.password The password to set for the thing sha256 hasshed or in clear text if nonHashed is true.
 * @param {Boolean} args.nonHashed Set to true if password is sent as clear text (not recommended).
 * @returns {}
 */

exports.updateUser = updateUser;
var updateUserCredentials = namedReq('conf/updateUserCredentials'); // ________________________________________________________
//  data-history

/**
 * Writes a batch directly to the data-history.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {String} args.channel The record id of the channel to write data history for.
 * @param {Array} args.data The historic data to write.
 * @param {Object} args.equidistance The distance between the data samples when writing equidistant data.
 * @param {String} args.timestamp The timestamp of the first sample when writing equidistant data.
 * @returns {void}
 */

exports.updateUserCredentials = updateUserCredentials;
var dataHistoryCreateBatch = namedReq('data-history/createBatch');
/**
 * Fetches data from the data-history.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {String} args.channel The record id of the channel to read historic data for.
 * @param {String} args.from A lower limit for the timestamps of the returned records.
 * @param {String} args.to An upper limit for the timestamps of the returned records.
 * @param {Array<String>} args.projection The projection to use for the read operation.
 * @param {Number} args.limit The maximum number of records to return.
 * @param {Boolean} args.ascending Set to true to receive data with ascending timestamps.
 * @returns {Array} The namedRequested records.
 */

exports.dataHistoryCreateBatch = dataHistoryCreateBatch;
var dataHistoryRead = namedReq('data-history/read');
/**
 * Deletes data from the data-history.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {String} args.channel The record id of the channel to delete historic data for.
 * @param {String} args.from A lower limit for the timestamps of records to delete.
 * @param {String} args.to An upper limit for the timestamps of the records to delete.
 * @returns {Number} Number of records deleted.
 */

exports.dataHistoryRead = dataHistoryRead;
var dataHistoryDelete = namedReq('data-history/delete'); // ________________________________________________________
//  mailer

/**
 * Sends an email depending on the provided parameters.
 * @func
 * @static
 * @param {Object} args Object specifying arguments:
 * @param {String} args.to The recipient mail addresses.
 * @param {String} args.subject The subject to set for the mail.
 * @param {String} args.text The pure text content to use as mail content.
 * @param {String} args.html The html content to use as mail content.
 * @returns {void}
 */

exports.dataHistoryDelete = dataHistoryDelete;
var mailerSend = namedReq('mailer/send'); // ________________________________________________________
//  presence

exports.mailerSend = mailerSend;
var presenceListClients = namedReq('presence/listClients');
exports.presenceListClients = presenceListClients;