"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getConnectionChecker = void 0;

var _fp = require("date-fns/esm/fp");

var R = _interopRequireWildcard(require("ramda"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var checkConnection = function checkConnection() {
  var connState = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var maxAbsence = arguments.length > 1 ? arguments[1] : undefined;
  if (!R.is(Number)(maxAbsence)) return _objectSpread({}, connState, {
    status: undefined
  });
  var _connState$latestTs = connState.latestTs,
      latestTs = _connState$latestTs === void 0 ? 0 : _connState$latestTs;
  var recent = R.compose((0, _fp.isAfter)(new Date()), (0, _fp.addSeconds)(maxAbsence));
  return {
    latestTs: latestTs,
    status: recent(latestTs)
  };
};

var bumpConnection = function bumpConnection() {
  var connState = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var time = arguments.length > 1 ? arguments[1] : undefined;
  return _objectSpread({}, connState, {
    latestTs: time
  });
};

var getConnectionChecker = function getConnectionChecker(cb) {
  var state;

  var run = function run(func) {
    return function (value) {
      state = func(state, value);
      if (cb) cb(state.status);
      return state.status;
    };
  };

  return {
    check: run(checkConnection),
    bump: run(bumpConnection)
  };
};

exports.getConnectionChecker = getConnectionChecker;