"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withUnit = void 0;

var _react = _interopRequireWildcard(require("react"));

var _beClient = require("../be-client");

var _unit = require("../unit");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }

function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }

// const hoc = connect(
//   state => ({ unitSettings: state.profile.unitSettings }),
//   () => ({}),
// );

/**
 * Transforms channel data with unit information in channelType.
 * @param {Object} settings Settings from widget config.
 * @param {String} settings.dataKey The property key to transform values on.
 * @param {Object} settings.unitKey The property key to pass the unit name on.
 * @param {Array<string>} settings.paths The property paths to transform.
 * @param {Boolean} settings.isMsg If true the value is a raw TiipMessage.
 */
var withUnit = function withUnit(_ref) {
  var dataKey = _ref.dataKey,
      _ref$unitKey = _ref.unitKey,
      unitKey = _ref$unitKey === void 0 ? 'unit' : _ref$unitKey,
      _ref$isMsg = _ref.isMsg,
      isMsg = _ref$isMsg === void 0 ? false : _ref$isMsg,
      channelRid = _ref.channelRid,
      _ref$unitSettings = _ref.unitSettings,
      unitSettings = _ref$unitSettings === void 0 ? {} : _ref$unitSettings;
  return function (Component) {
    var WithUnit = function WithUnit(_ref2) {
      var _ref3;

      var data = _ref2[dataKey],
          rest = _objectWithoutProperties(_ref2, [dataKey].map(_toPropertyKey));

      var _useState = (0, _react.useState)({}),
          _useState2 = _slicedToArray(_useState, 2),
          state = _useState2[0],
          setState = _useState2[1];

      var converter = (0, _react.useRef)();
      var targetUnit = state.targetUnit;
      (0, _react.useEffect)(function () {
        // Load channel type info to get unit of the data, and create converter
        (0, _beClient.getUnitFromChannel)(channelRid).then(function (unit) {
          var kind = (0, _unit.unitToKind)(unit);
          var toUnit = unitSettings[kind];

          if (toUnit && !Object.is(unit, toUnit)) {
            // console.log('Creating converter:', unit, '->', toUnit);
            var _getConverter = (0, _unit.getConverter)(unit, toUnit),
                _getConverter2 = _slicedToArray(_getConverter, 2),
                resultingUnit = _getConverter2[0],
                conv = _getConverter2[1];

            if (resultingUnit && conv && !Object.is(unit, resultingUnit)) {
              console.log('Converter created:', unit, '->', resultingUnit);
              converter.current = conv;
              setState(_objectSpread({}, state, {
                loading: false,
                targetUnit: resultingUnit
              }));
            }
          }

          setState(_objectSpread({}, state, {
            loading: false
          }));
        });
      }, [setState, unitSettings, channelRid]); // useEffect(() => {
      //
      // }, [data]);
      // const newData = (() => {

      var newData = (0, _react.useMemo)(function () {
        // if target unit or data changes -> convert data again
        if (!converter.current) return data;

        if (isMsg) {
          if (Array.isArray(data)) {
            return data.map(function (msg) {
              return _objectSpread({}, msg, {
                pl: converter.current(msg.pl || [])
              });
            });
          }

          return _objectSpread({}, data, {
            pl: converter.current(data.pl || [])
          });
        }

        return converter.current(data);
      }, [data, isMsg, converter.current]); // })();

      console.log('WithUnit render - channelRid, dataKey, data, newData:', channelRid, dataKey, data, newData); // return loading ? (
      //   <CircularProgress />
      // ) : (

      return _react["default"].createElement(Component, _extends({}, rest, (_ref3 = {}, _defineProperty(_ref3, dataKey, newData), _defineProperty(_ref3, unitKey, targetUnit), _ref3), {
        key: targetUnit
      })); // );
    };

    return WithUnit;
  };
};

exports.withUnit = withUnit;