"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useArray = void 0;

var _react = require("react");

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var useArray = function useArray(initial) {
  var _useState = (0, _react.useState)(initial || []),
      _useState2 = _slicedToArray(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1];

  return {
    value: value,
    setValue: setValue,
    unshift: (0, _react.useCallback)(function (a) {
      return setValue(function (v) {
        return [a].concat(_toConsumableArray(v));
      });
    }, []),
    add: (0, _react.useCallback)(function (a) {
      return setValue(function (v) {
        return [].concat(_toConsumableArray(v), [a]);
      });
    }, []),
    clear: (0, _react.useCallback)(function () {
      return setValue(function () {
        return [];
      });
    }, []),
    removeById: (0, _react.useCallback)(function (id) {
      return setValue(function (arr) {
        return arr.filter(function (v) {
          return v && v.id !== id;
        });
      });
    }, []),
    removeIndex: (0, _react.useCallback)(function (index) {
      return setValue(function (v) {
        v.splice(index, 1);
        return v;
      });
    }, [])
  };
};

exports.useArray = useArray;