"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useScrollThresholdToggle = void 0;

var _react = require("react");

var useScrollThresholdToggle = function useScrollThresholdToggle(threshold, toggler) {
  (0, _react.useEffect)(function () {
    toggler(false);

    window.onscroll = function () {
      var scrolled = document.body.scrollTop > threshold || document.documentElement.scrollTop > threshold;

      if (scrolled) {
        toggler(true);
      } else {
        toggler(false);
      }
    };

    return function () {
      toggler(true);
      window.onscroll = Function.prototype;
    };
  }, []);
};

exports.useScrollThresholdToggle = useScrollThresholdToggle;