"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.contentHeight = exports.appBarHeight = exports.contentWidth = exports.isMenuShown = exports.drawerWidthDefault = void 0;
var drawerWidthDefault = 240;
exports.drawerWidthDefault = drawerWidthDefault;

var isMenuShown = function isMenuShown(theme, width) {
  return width > theme.breakpoints.values.md;
};

exports.isMenuShown = isMenuShown;

var contentWidth = function contentWidth(theme, width) {
  var drawerWidth = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : drawerWidthDefault;
  return isMenuShown(theme, width) ? width - drawerWidth : width;
}; // TODO: Should replicate theme.mixins.toolbar correctly!


exports.contentWidth = contentWidth;

var appBarHeight = function appBarHeight(theme, width) {
  return width < theme.breakpoints.width('sm') ? theme.mixins.toolbar.minHeight : theme.mixins.toolbar['@media (min-width:600px)'].minHeight;
};

exports.appBarHeight = appBarHeight;

var contentHeight = function contentHeight(theme, width, height) {
  return height - appBarHeight(theme, width);
};

exports.contentHeight = contentHeight;