"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Chart = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _chart = _interopRequireDefault(require("chart.js"));

var R = _interopRequireWildcard(require("ramda"));

var _subSeconds = _interopRequireDefault(require("date-fns/fp/subSeconds"));

var _transforms = require("../transforms");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// import { generateString } from '../data-utils';
var propTypes = {
  data: _propTypes["default"].objectOf(_propTypes["default"].any),
  style: _propTypes["default"].objectOf(_propTypes["default"].any),
  type: _propTypes["default"].string,
  options: _propTypes["default"].objectOf(_propTypes["default"].any),
  values: _propTypes["default"].arrayOf(_propTypes["default"].any),
  point: _propTypes["default"].objectOf(_propTypes["default"].any),
  points: _propTypes["default"].arrayOf(_propTypes["default"].object),
  length: _propTypes["default"].number,
  ttl: _propTypes["default"].number
};
var defaultProps = {
  style: {},
  data: undefined,
  values: undefined,
  type: 'line',
  options: {},
  point: {},
  points: undefined,
  length: undefined,
  ttl: undefined
};
var pointRadius = 1.3;
var chartColors = ['rgb(50, 152, 235)', 'rgb(255, 159, 64)', 'rgb(75, 185, 92)', 'rgb(153, 102, 255)', 'rgb(255, 99, 99)', 'rgb(255, 205, 86)', 'rgb(190, 90, 60)', 'rgb(231, 80, 200)', 'rgb(60, 203, 180)', 'rgb(255, 20, 0)', 'rgb(201, 203, 207)'];
var defaultCanvasStyle = {
  width: 300,
  height: 300
};
var commonOptions = {
  animation: {
    duration: 200
  },
  // animation: {
  //   duration: 0, // general animation time
  // },
  hover: {
    animationDuration: 0 // duration of animations when hovering an item

  },
  responsiveAnimationDuration: 0,
  // animation duration after a resize
  legend: {
    labels: {
      boxWidth: 6
    }
  }
};

var getDefaultDataset = function getDefaultDataset(idx) {
  var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  return {
    fill: false,
    label: "pl[".concat(idx, "]"),
    data: data,
    backgroundColor: chartColors[idx],
    borderColor: chartColors[idx],
    pointRadius: pointRadius,
    spanGaps: true
  };
};

var defaultOptions = {
  bar: _objectSpread({}, commonOptions),
  line: _objectSpread({}, commonOptions, {
    // tooltips: { enabled: false },
    scales: {
      xAxes: [{
        type: 'time',
        time: {
          parser: 'HH:mm:ss',
          tooltipFormat: 'D MMM HH:mm:ss',
          minUnit: 'second',
          displayFormats: {
            millisecond: 'mm:ss.SSS',
            second: 'HH:mm:ss',
            minute: 'HH:mm',
            hour: 'D HH'
          }
        },
        scaleLabel: {
          display: false // labelString: 'Date',

        }
      }],
      yAxes: [{
        scaleLabel: {
          display: false // labelString: 'value',

        }
      }]
    }
  })
};

var adjustDatasetsToPayload = function adjustDatasetsToPayload(datasets, payload) {
  while (datasets.length < payload.length) {
    datasets.push(getDefaultDataset(datasets.length, R.repeat(null, datasets[0] ? datasets[0].data.length : 0)));
  }

  while (datasets.length > payload.length) {
    datasets.pop();
  }
};

var pointIntoChart = R.curry(function (chart, _ref, point) {
  var length = _ref.length,
      ttl = _ref.ttl;
  var x = point.x || point.ts || point.timestamp || point.time || new Date();
  var ys = point.payload || point.pl || point.data || [null]; // Add or remove datasets depending on number of ys:

  adjustDatasetsToPayload(chart.data.datasets, ys); // Calculate if we should cut the tail

  var chronologicStart = (0, _transforms.nilOrEmpty)(chart.data.labels) || x > chart.data.labels[0]; // let remove = true;

  var remove = 0;

  if (ttl) {
    remove = R.findIndex(R.lt((0, _subSeconds["default"])(ttl)(x)))(chart.data.labels); // console.log('ttl present:', ttl, length);
    // console.log('Remove count:', remove);
  } else if (length) {
    remove = 1;
    if (chronologicStart && chart.data.labels.length < length) remove = 0;
  }

  chart.data.labels.splice(0, remove); // R.forEach(chart.data.labels.shift)(R.range(0, remove));

  chart.data.labels.push(x); // if (length && chronologicStart && chart.data.labels.length < length) remove = false;
  // if (remove) chart.data.labels.shift();

  chart.data.datasets.forEach(function (ds, ix) {
    var val = ys[ix]; // if (!R.is(Object, val) && !R.is(Number, val) && !R.isNil(val)) val = { data: val };
    // if (R.is(Object, val)) val.valueOf = () => 0;

    ds.data.push(val);
    ds.data.splice(0, remove); // R.forEach(ds.data.shift)(R.range(0, remove));
    // if (remove) ds.data.shift();
  });
});

var fixDatasetStyle = function fixDatasetStyle(ds, ix) {
  /* eslint-disable no-param-reassign */
  R.mapObjIndexed(function (val, key) {
    ds[key] = ds[key] || val;
  })(getDefaultDataset(ix, ds.data)); // if (!ds.backgroundColor) ds.backgroundColor = chartColors[ix];
  // if (!ds.borderColor) ds.borderColor = chartColors[ix];
  // if (!ds.pointRadius) ds.pointRadius = pointRadius;

  /* eslint-enable no-param-reassign */
};

var Chart = function Chart(_ref2) {
  var style = _ref2.style,
      type = _ref2.type,
      _ref2$data = _ref2.data,
      data = _ref2$data === void 0 ? {} : _ref2$data,
      options = _ref2.options,
      point = _ref2.point,
      points = _ref2.points,
      length = _ref2.length,
      values = _ref2.values,
      ttl = _ref2.ttl,
      rest = _objectWithoutProperties(_ref2, ["style", "type", "data", "options", "point", "points", "length", "values", "ttl"]);

  var canvasRef = (0, _react.useRef)(null);
  var chart = (0, _react.useRef)(null); // const chartId = useRef(generateString(8));

  (0, _react.useEffect)(function () {
    console.log('Chart init:', type, data, options, point, points, length, ttl);

    if (!chart.current) {
      /* eslint-disable no-param-reassign */
      if (!Array.isArray(data.datasets)) data.datasets = [];
      /* eslint-enable no-param-reassign */

      data.datasets.forEach(fixDatasetStyle);
      chart.current = new _chart["default"](canvasRef.current, {
        type: type,
        data: data,
        options: R.mergeDeepLeft(options, defaultOptions[type])
      });
    }
  }, []);
  (0, _react.useEffect)(function () {
    if ((0, _transforms.nilOrEmpty)(points)) return;
    R.map(pointIntoChart(chart.current, {
      length: length,
      ttl: ttl
    }))(points);
    chart.current.update();
  }, [points]);
  (0, _react.useEffect)(function () {
    if ((0, _transforms.nilOrEmpty)(point)) return;
    pointIntoChart(chart.current, {
      length: length || 10,
      ttl: ttl
    }, point);
    chart.current.update();
  }, [point]);
  (0, _react.useEffect)(function () {
    if ((0, _transforms.nilOrEmpty)(values)) return;
    chart.current.data.datasets[0].data = values;
  }, [values]);

  var canvasStyle = _objectSpread({}, defaultCanvasStyle, {}, style); // canvasStyle.minHeight = canvasStyle.height;


  return (0, _react.useMemo)(function () {
    return _react["default"].createElement("canvas", _extends({
      // id={chartId}
      ref: canvasRef,
      width: canvasStyle.width,
      height: canvasStyle.height,
      style: canvasStyle
    }, rest));
  }, [chart.current]);
};

exports.Chart = Chart;
Chart.propTypes = propTypes;
Chart.defaultProps = defaultProps;