"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DashboardGenerator = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _useMediaQuery = _interopRequireDefault(require("@material-ui/core/useMediaQuery"));

var _styles = require("@material-ui/styles");

var R = _interopRequireWildcard(require("ramda"));

var _Widget = require("./Widget");

var _transforms = require("../transforms");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var defaultWidth = 300;
var wideWidth = 616;
var contentHeight = 332; // const ensureArray = R.when(R.complement(R.is)(Array), R.of);

var appliedArgToFuncReducer = function appliedArgToFuncReducer(funcMap, argMap) {
  return function (hocs, key) {
    return R.append(funcMap[key].apply(funcMap, _toConsumableArray((0, _transforms.ensureArray)(argMap[key]))))(hocs);
  };
};

var propTypes = {
  dashboardConfig: _propTypes["default"].objectOf(_propTypes["default"].any),
  asset: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired,
  theme: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired,
  componentMap: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired,
  widgetHocMap: _propTypes["default"].objectOf(_propTypes["default"].func),
  defaultHoc: _propTypes["default"].func
};
var defaultProps = {
  dashboardConfig: {},
  widgetHocMap: {},
  defaultHoc: undefined
};
var hoc = _styles.withTheme;

var updateCache = function updateCache(type) {
  var defaultOrder = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var currentOrder = arguments.length > 2 ? arguments[2] : undefined;
  if (!type) return {
    widgetOrder: currentOrder || defaultOrder
  };
  var cache = JSON.parse(localStorage.getItem("aT_".concat(type))) || {};
  var version = JSON.stringify(defaultOrder);
  var data;
  if (cache.version !== version) data = {
    widgetOrder: defaultOrder,
    version: version
  };else data = {
    widgetOrder: currentOrder || cache.widgetOrder || defaultOrder,
    version: version
  };
  localStorage.setItem("aT_".concat(type), JSON.stringify(data));
  return data;
};

var DashboardGeneratorC = function DashboardGeneratorC(_ref) {
  var _ref$dashboardConfig = _ref.dashboardConfig,
      _ref$dashboardConfig$ = _ref$dashboardConfig.widgets,
      widgets = _ref$dashboardConfig$ === void 0 ? [] : _ref$dashboardConfig$,
      widgetsInDashboard = _ref$dashboardConfig.widgetsInDashboard,
      type = _ref.asset.type,
      theme = _ref.theme,
      componentMap = _ref.componentMap,
      widgetHocMap = _ref.widgetHocMap,
      defaultHoc = _ref.defaultHoc;

  // console.log('DaGen props:', widgets, widgetsInDashboard, type, 'componentMap:', componentMap);
  var _useState = (0, _react.useState)([]),
      _useState2 = _slicedToArray(_useState, 2),
      widgetOrder = _useState2[0],
      setWidgetOrder = _useState2[1];

  var widgetComponent = (0, _react.useRef)({});
  var updateWidgetOrder = (0, _react.useCallback)(function (currentOrder) {
    var data = updateCache(type, widgetsInDashboard || R.pluck('id')(widgets), currentOrder);
    setWidgetOrder(data.widgetOrder);
  }, [setWidgetOrder, widgetsInDashboard, widgets]);
  (0, _react.useEffect)(function () {
    /* Clean up old items */
    var temporaryToRemoveOld = type && localStorage.getItem(type);

    if (temporaryToRemoveOld) {
      var order = JSON.parse(temporaryToRemoveOld).widgetOrder;
      if (order) localStorage.removeItem(type);
    }
    /* End of Clean up */

  }, [type]);
  (0, _react.useEffect)(function () {
    updateWidgetOrder();
  }, [updateWidgetOrder]);
  var moveWidget = (0, _react.useCallback)(function (id, step) {
    var fromIndex = widgetOrder.indexOf(id);
    if (fromIndex === 0) return;
    var newOrder = R.move(fromIndex, fromIndex + step)(widgetOrder);
    updateWidgetOrder(newOrder);
  }, [widgetOrder, updateWidgetOrder]);
  var getCommonMenuItems = (0, _react.useCallback)(function (id) {
    return [{
      label: 'Move left',
      // tLabel('moveLeft', lang)
      icon: 'mdi-arrow-top-left',
      method: function method() {
        return moveWidget(id, -1);
      }
    }, {
      label: 'Move right',
      // tLabel('moveRight', lang)
      icon: 'mdi-arrow-bottom-right',
      method: function method() {
        return moveWidget(id, 1);
      }
    }];
  }, [moveWidget]);
  var widgetBuilder = (0, _react.useCallback)(function (widgetConf, dynWidth) {
    var id = widgetConf.id,
        wHoc = widgetConf.hoc,
        component = widgetConf.component,
        responsive = widgetConf.responsive,
        _widgetConf$justify = widgetConf.justify,
        justify = _widgetConf$justify === void 0 ? 'center' : _widgetConf$justify,
        _widgetConf$align = widgetConf.align,
        align = _widgetConf$align === void 0 ? 'center' : _widgetConf$align,
        _widgetConf$contentPr = widgetConf.contentProps,
        contentProps = _widgetConf$contentPr === void 0 ? {} : _widgetConf$contentPr,
        _widgetConf$frameProp = widgetConf.frameProps,
        frameProps = _widgetConf$frameProp === void 0 ? {} : _widgetConf$frameProp,
        rest = _objectWithoutProperties(widgetConf, ["id", "hoc", "component", "responsive", "justify", "align", "contentProps", "frameProps"]);

    if (!widgetComponent.current[id]) {
      var _componentMap$compone = componentMap[component],
          Inner = _componentMap$compone === void 0 ? R.F : _componentMap$compone;
      var hocConfs = R.pick(Object.keys(widgetHocMap))(rest); // const hocFuncs = R.pick(Object.keys(rest))(widgetHocMap);

      var wHocs = R.compose(R.when(function () {
        return !!defaultHoc;
      }, R.append(defaultHoc)), R.when(function () {
        return !!wHoc;
      }, R.append(wHoc)), R.reduce(appliedArgToFuncReducer(widgetHocMap, hocConfs), []), R.keys)(hocConfs);
      var widgetHoc = R.isEmpty(wHocs) ? R.identity : R.compose.apply(R, _toConsumableArray(wHocs));
      widgetComponent.current[id] = widgetHoc(Inner);
    }

    var Component = widgetComponent.current[id];
    var width = responsive ? dynWidth : defaultWidth;
    var _frameProps$menuItems = frameProps.menuItems,
        menuItems = _frameProps$menuItems === void 0 ? [] : _frameProps$menuItems;
    return _react["default"].createElement(_Widget.Widget, _extends({
      key: id,
      width: width
    }, R.assoc('menuItems', R.concat(getCommonMenuItems(id), menuItems))(frameProps), {
      style: {
        marginTop: 16,
        marginLeft: 16
      }
    }), _react["default"].createElement("div", {
      style: {
        display: 'flex',
        justifyContent: justify,
        alignItems: align,
        width: '100%'
      }
    }, _react["default"].createElement(Component, _extends({
      style: {
        height: contentHeight,
        width: width
      }
    }, contentProps))));
  }, [getCommonMenuItems, componentMap, widgetHocMap, widgetComponent.current]);
  var wide = (0, _useMediaQuery["default"])(theme.breakpoints.up('md'));
  var dynWidth = wide ? wideWidth : defaultWidth;
  var widgetMapper = (0, _react.useCallback)(function (id) {
    var conf = R.find(R.propEq('id', id))(widgets); // console.log('DaGen render widget:', conf);

    return conf && conf.component ? widgetBuilder(conf, dynWidth) : null;
  }, [widgets, widgetBuilder]); // console.log('DaGen b4 render:', widgetOrder);

  return _react["default"].createElement("div", null, R.map(widgetMapper)(widgetOrder));
};

DashboardGeneratorC.propTypes = propTypes;
DashboardGeneratorC.defaultProps = defaultProps;
var DashboardGenerator = hoc(DashboardGeneratorC);
exports.DashboardGenerator = DashboardGenerator;