"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _styles = require("@material-ui/core/styles");

var _Icon = _interopRequireDefault(require("@material-ui/core/Icon"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var styles = function styles(theme) {
  return {
    actionButton: {
      position: 'relative'
    },
    cancelButton: {
      position: 'relative'
    },
    button: {
      margin: theme.spacing(1),
      marginLeft: 0
    },
    icon: {
      marginLeft: theme.spacing(1)
    }
  };
};

var propTypes = {
  style: _propTypes["default"].objectOf(_propTypes["default"].any),
  firstButtonText: _propTypes["default"].string.isRequired,
  secondButtonText: _propTypes["default"].string.isRequired,
  editingOn: _propTypes["default"].bool.isRequired,
  disabled: _propTypes["default"].bool.isRequired,
  onEditingOn: _propTypes["default"].func.isRequired,
  onSave: _propTypes["default"].func.isRequired,
  onCancel: _propTypes["default"].func.isRequired,
  classes: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired
};
var defaultProps = {
  style: {}
};

var EditCancelSaveButtons = function EditCancelSaveButtons(_ref) {
  var editingOn = _ref.editingOn,
      onSave = _ref.onSave,
      onCancel = _ref.onCancel,
      onEditingOn = _ref.onEditingOn,
      style = _ref.style,
      firstButtonText = _ref.firstButtonText,
      secondButtonText = _ref.secondButtonText,
      disabled = _ref.disabled,
      classes = _ref.classes;
  return _react["default"].createElement("div", {
    style: style
  }, _react["default"].createElement(_Button["default"], {
    variant: "contained",
    className: classes.button,
    color: "primary",
    type: "submit",
    onClick: editingOn ? onSave : onEditingOn,
    disabled: disabled
  }, firstButtonText, _react["default"].createElement(_Icon["default"], {
    className: classes.icon
  }, editingOn ? 'save' : 'edit')), editingOn && _react["default"].createElement(_Button["default"], {
    variant: "contained",
    className: classes.button,
    onClick: onCancel
  }, secondButtonText, _react["default"].createElement(_Icon["default"], {
    className: classes.icon
  }, "clear")));
};

EditCancelSaveButtons.propTypes = propTypes;
EditCancelSaveButtons.defaultProps = defaultProps;

var _default = (0, _styles.withStyles)(styles)(EditCancelSaveButtons);

exports["default"] = _default;