"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FlippableAvatar = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Avatar = _interopRequireDefault(require("@material-ui/core/Avatar"));

var _Icon = _interopRequireDefault(require("@material-ui/core/Icon"));

var _Tooltip = _interopRequireDefault(require("@material-ui/core/Tooltip"));

var _classnames = _interopRequireDefault(require("classnames"));

var _styles = require("@material-ui/core/styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var styles = function styles() {
  return {
    checkicon: {
      backgroundColor: 'green'
    },
    flipContainer: {
      perspective: 1000,
      height: 40,
      width: 40,
      backfaceVisibility: 'hidden',
      transition: '0.6s',
      transformStyle: 'preserve-3d',
      position: 'relative'
    },
    hover: {
      transform: 'scale(1.1)'
    },
    flipped: {
      transform: 'rotateY(180deg)'
    },
    back: {
      transform: 'rotateY(180deg)',
      position: 'absolute'
    },
    front: {
      position: 'absolute'
    },
    tooltip: {
      width: 64,
      height: 64,
      position: 'absolute',
      top: 0,
      left: 0
    }
  };
};

var propTypes = {
  style: _propTypes["default"].objectOf(_propTypes["default"].any),
  classes: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired,
  src: _propTypes["default"].string,
  tooltipText: _propTypes["default"].string,
  onChange: _propTypes["default"].func
};
var defaultProps = {
  style: {},
  src: 'A',
  onChange: function onChange() {},
  tooltipText: undefined
};

var __FlippableAvatar = function __FlippableAvatar(_ref) {
  var style = _ref.style,
      classes = _ref.classes,
      src = _ref.src,
      tooltipText = _ref.tooltipText,
      onChange = _ref.onChange;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      flipped = _useState2[0],
      setFlipped = _useState2[1];

  var flip = function flip(ev) {
    ev.stopPropagation();
    onChange(!flipped);
    setFlipped(!flipped);
  };

  var text = src.length < 3 ? src : undefined;
  var image = src.length > 3 ? src : undefined; // console.log('tooltipText in FlippableAvatar()', tooltipText);

  return _react["default"].createElement("div", {
    style: style,
    onClick: flip
  }, _react["default"].createElement("div", {
    id: "flipcontainer",
    className: (0, _classnames["default"])(classes.flipContainer, flipped && classes.flipped),
    onClick: flip,
    role: "status"
  }, _react["default"].createElement(_Avatar["default"], {
    className: classes.back,
    classes: {
      root: classes.checkicon
    }
  }, _react["default"].createElement(_Icon["default"], null, "check")), _react["default"].createElement(_Avatar["default"], {
    src: image,
    className: classes.front
  }, text)), tooltipText && _react["default"].createElement(_Tooltip["default"], {
    id: "avatar-tooltip",
    title: tooltipText,
    placement: "right"
  }, _react["default"].createElement("div", {
    className: classes.tooltip
  })));
};

__FlippableAvatar.propTypes = propTypes;
__FlippableAvatar.defaultProps = defaultProps;
var FlippableAvatar = (0, _styles.withStyles)(styles)(__FlippableAvatar);
exports.FlippableAvatar = FlippableAvatar;