"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ItemPicker = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var R = _interopRequireWildcard(require("ramda"));

var _styles = require("@material-ui/core/styles");

var _Chip = _interopRequireDefault(require("@material-ui/core/Chip"));

var _MenuItem = _interopRequireDefault(require("@material-ui/core/MenuItem"));

var _FormControl = _interopRequireDefault(require("@material-ui/core/FormControl"));

var _Input = _interopRequireDefault(require("@material-ui/core/Input"));

var _InputLabel = _interopRequireDefault(require("@material-ui/core/InputLabel"));

var _Select = _interopRequireDefault(require("@material-ui/core/Select"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = {
  classes: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired,
  items: _propTypes["default"].objectOf(_propTypes["default"].any),
  dataSourceConfig: _propTypes["default"].objectOf(_propTypes["default"].string),
  addChipCallback: _propTypes["default"].func.isRequired,
  deleteChipCallback: _propTypes["default"].func.isRequired,
  selectedItems: _propTypes["default"].arrayOf(_propTypes["default"].string),
  floatingLabelText: _propTypes["default"].string,
  disabled: _propTypes["default"].bool
};
var defaultProps = {
  items: {},
  selectedItems: [],
  disabled: false,
  floatingLabelText: 'Select Items',
  dataSourceConfig: {
    text: 'name',
    value: 'id'
  }
};

var styles = function styles(theme) {
  var _chips;

  return {
    selectField: {
      minWidth: 180,
      maxWidth: 256,
      display: 'block',
      marginTop: theme.spacing(1)
    },
    chip: {
      marginTop: theme.spacing(1),
      marginRight: theme.spacing(1)
    },
    chips: (_chips = {
      display: 'flex'
    }, _defineProperty(_chips, theme.breakpoints.down('md'), {
      maxWidth: 512
    }), _defineProperty(_chips, "flexWrap", 'wrap'), _defineProperty(_chips, "marginTop", theme.spacing(2)), _chips)
  };
};

var hoc = (0, _styles.withStyles)(styles);

var ItemPickerComponent = function ItemPickerComponent(_ref) {
  var _ref$dataSourceConfig = _ref.dataSourceConfig,
      name = _ref$dataSourceConfig.text,
      value = _ref$dataSourceConfig.value,
      items = _ref.items,
      selectedItems = _ref.selectedItems,
      addChipCallback = _ref.addChipCallback,
      deleteChipCallback = _ref.deleteChipCallback,
      floatingLabelText = _ref.floatingLabelText,
      disabled = _ref.disabled,
      classes = _ref.classes;

  var handleSelect = function handleSelect(newItems) {
    if (newItems.length > selectedItems.length) {
      var newItem = newItems.find(function (i) {
        return !selectedItems.includes(i);
      });
      if (newItem) addChipCallback(newItem);
    } else if (newItems.length < selectedItems.length) {
      var deletedItem = selectedItems.find(function (i) {
        return !newItems.includes(i);
      });
      deleteChipCallback(deletedItem);
    }
  };

  return _react["default"].createElement("div", null, _react["default"].createElement(_FormControl["default"], {
    disabled: disabled
  }, _react["default"].createElement(_InputLabel["default"], {
    htmlFor: "select"
  }, floatingLabelText), selectedItems.length >= 1 && _react["default"].createElement("div", {
    className: classes.chips
  }, selectedItems.map(function (id) {
    return _react["default"].createElement(_Chip["default"], {
      label: R.pathOr('No label', [id, name], items),
      key: id,
      onDelete: disabled ? undefined : function () {
        return deleteChipCallback(id);
      },
      className: classes.chip
    });
  })), _react["default"].createElement(_Select["default"], {
    onChange: function onChange(e) {
      return handleSelect(e.target.value);
    },
    value: selectedItems,
    multiple: true,
    className: classes.selectField,
    input: _react["default"].createElement(_Input["default"], {
      name: "select",
      id: "select"
    })
  }, Object.values(items).map(function (item, ix) {
    var _item$value = item[value],
        val = _item$value === void 0 ? ix : _item$value,
        _item$name = item[name],
        label = _item$name === void 0 ? 'No name' : _item$name;
    return _react["default"].createElement(_MenuItem["default"], {
      key: val,
      value: val
    }, label);
  }))));
};

ItemPickerComponent.propTypes = propTypes;
ItemPickerComponent.defaultProps = defaultProps;
var ItemPicker = hoc(ItemPickerComponent);
exports.ItemPicker = ItemPicker;