"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Page = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactDocumentTitle = _interopRequireDefault(require("react-document-title"));

var _styles = require("@material-ui/core/styles");

var _Paper = _interopRequireDefault(require("@material-ui/core/Paper"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var propTypes = {
  title: _propTypes["default"].string,
  topBar: _propTypes["default"].node,
  noPaperBg: _propTypes["default"].bool,
  children: _propTypes["default"].node.isRequired,
  classes: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired,
  paperBgStyle: _propTypes["default"].objectOf(_propTypes["default"].any)
};
var defaultProps = {
  title: '',
  topBar: false,
  noPaperBg: false,
  paperBgStyle: {}
};

var styles = function styles(theme) {
  return {
    toolbar: theme.mixins.toolbar,
    bg: {
      width: '100vw',
      minHeight: '100vh',
      position: 'fixed',
      zIndex: -1
    }
  };
};

var hoc = (0, _styles.withStyles)(styles, {
  withTheme: true
});

var PageC = function PageC(_ref) {
  var title = _ref.title,
      children = _ref.children,
      classes = _ref.classes,
      noPaperBg = _ref.noPaperBg,
      paperBgStyle = _ref.paperBgStyle,
      topBar = _ref.topBar;
  return _react["default"].createElement(_reactDocumentTitle["default"], {
    title: title
  }, _react["default"].createElement(_react["default"].Fragment, null, !noPaperBg && _react["default"].createElement(_Paper["default"], {
    elevation: 0,
    className: classes.bg,
    style: paperBgStyle
  }), topBar, topBar && _react["default"].createElement("div", {
    className: classes.toolbar
  }), children));
};

PageC.propTypes = propTypes;
PageC.defaultProps = defaultProps;
var Page = hoc(PageC);
exports.Page = Page;