"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PagePadding = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames2 = _interopRequireDefault(require("classnames"));

var _styles = require("@material-ui/core/styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// import Paper from '@material-ui/core/Paper';
var styles = function styles(theme) {
  return {
    paddingT: _defineProperty({
      paddingTop: theme.spacing(2)
    }, theme.breakpoints.up('sm'), {
      paddingTop: theme.spacing(3)
    }),
    paddingB: {
      paddingBottom: 100
    },
    paddingH: _defineProperty({
      paddingLeft: theme.spacing(1),
      paddingRight: theme.spacing(1)
    }, theme.breakpoints.up('sm'), {
      paddingLeft: theme.spacing(3),
      paddingRight: theme.spacing(3)
    })
  };
};

var propTypes = {
  children: _propTypes["default"].node.isRequired,
  noHoriz: _propTypes["default"].bool,
  noBot: _propTypes["default"].bool,
  noTop: _propTypes["default"].bool,
  className: _propTypes["default"].string,
  classes: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired,
  style: _propTypes["default"].objectOf(_propTypes["default"].any)
};
var defaultProps = {
  noHoriz: false,
  noBot: false,
  noTop: false,
  className: undefined,
  style: {}
};

var PagePaddingC = function PagePaddingC(_ref) {
  var _classnames;

  var noHoriz = _ref.noHoriz,
      noBot = _ref.noBot,
      noTop = _ref.noTop,
      classes = _ref.classes,
      children = _ref.children,
      style = _ref.style,
      className = _ref.className;
  return _react["default"].createElement("div", {
    className: (0, _classnames2["default"])((_classnames = {}, _defineProperty(_classnames, className, !!className), _defineProperty(_classnames, classes.paddingT, !noTop), _defineProperty(_classnames, classes.paddingB, !noBot), _defineProperty(_classnames, classes.paddingH, !noHoriz), _classnames)),
    style: style
  }, children);
};

PagePaddingC.propTypes = propTypes;
PagePaddingC.defaultProps = defaultProps;
var PagePadding = (0, _styles.withStyles)(styles)(PagePaddingC);
exports.PagePadding = PagePadding;