"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RealtimeChart = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _chart = _interopRequireDefault(require("chart.js"));

var R = _interopRequireWildcard(require("ramda"));

var _transforms = require("../transforms");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * THIS COMPONENT IS OLD AND NOT UPDATED. USE Chart.js
 */
var propTypes = {
  data: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func]).isRequired,
  style: _propTypes["default"].objectOf(_propTypes["default"].any),
  type: _propTypes["default"].string,
  options: _propTypes["default"].objectOf(_propTypes["default"].any),
  payload: _propTypes["default"].arrayOf(_propTypes["default"].number),
  // eslint-disable-line
  length: _propTypes["default"].number // eslint-disable-line

};
var defaultProps = {
  style: {},
  type: 'line',
  options: {},
  payload: [],
  length: 10
};
var pointRadius = 0;
var chartColors = ['rgb(50, 152, 235)', 'rgb(255, 159, 64)', 'rgb(75, 185, 92)', 'rgb(153, 102, 255)', 'rgb(255, 99, 99)', 'rgb(255, 205, 86)', 'rgb(190, 90, 60)', 'rgb(231, 80, 200)', 'rgb(60, 203, 180)', 'rgb(255, 20, 0)', 'rgb(201, 203, 207)'];
var defaultCanvasStyle = {
  width: 300,
  height: 300
};
var commonOptions = {
  animation: {
    duration: 200
  },
  legend: {
    labels: {
      boxWidth: 6
    }
  }
};
var defaultOptions = {
  bar: _objectSpread({}, commonOptions),
  line: _objectSpread({}, commonOptions, {
    tooltips: {
      enabled: false
    },
    scales: {
      xAxes: [{
        type: 'time',
        time: {
          parser: 'mm:ss',
          tooltipFormat: 'mm:ss',
          minUnit: 'second',
          displayFormats: {
            second: 'mm:ss'
          }
        },
        scaleLabel: {
          display: false // labelString: 'Date',

        }
      }],
      yAxes: [{
        scaleLabel: {
          display: false // labelString: 'value',

        }
      }]
    }
  })
};
var payloadIntoChart = R.curry(function (chart, length, payload) {
  var dataArrays = [chart.data.labels].concat(_toConsumableArray(R.pluck('data', chart.data.datasets)));
  var remove = true;

  if (payload[0] > dataArrays[0][0] && dataArrays[0].length < length) {
    remove = false;
  }

  dataArrays.forEach(function (da, ix) {
    da.push(payload[ix]);
    if (remove) da.shift();
  });
});

var RealtimeChart = function RealtimeChart(_ref) {
  var style = _ref.style,
      type = _ref.type,
      data = _ref.data,
      options = _ref.options,
      payload = _ref.payload,
      length = _ref.length,
      rest = _objectWithoutProperties(_ref, ["style", "type", "data", "options", "payload", "length"]);

  var canvasRef = (0, _react.useRef)(null);
  var chart = (0, _react.useRef)(null);
  (0, _react.useEffect)(function () {
    // console.log('Chart init:', type, JSON.stringify(data));
    if (!chart.current) {
      /* eslint-disable no-param-reassign */
      data.datasets.forEach(function (ds, ix) {
        if (!ds.backgroundColor) ds.backgroundColor = chartColors[ix];
        if (!ds.borderColor) ds.borderColor = chartColors[ix];
        if (!ds.pointRadius) ds.pointRadius = pointRadius;
      });
      /* eslint-enable no-param-reassign */

      chart.current = new _chart["default"](canvasRef.current, {
        type: type,
        data: data,
        options: R.mergeDeepLeft(options, defaultOptions[type])
      });
    }
  }, []);
  (0, _react.useEffect)(function () {
    if ((0, _transforms.nilOrEmpty)(payload)) return; // console.log('Chart update:', payload);

    if (length === 0) {
      // console.log('length is 0: payload -> data');
      if (Array.isArray(payload[0])) {// Support multiple datasets (?)
      } else {
        chart.current.data.datasets[0].data = payload;
      }
    } else if (Array.isArray(payload[0])) {
      R.map(payloadIntoChart(chart.current, length))(payload);
    } else {
      payloadIntoChart(chart.current, length)(payload);
    }

    chart.current.update();
  }, [payload]);

  var canvasStyle = _objectSpread({}, defaultCanvasStyle, {}, style); // canvasStyle.minHeight = canvasStyle.height;


  return _react["default"].createElement("canvas", _extends({
    ref: canvasRef,
    width: canvasStyle.width,
    height: canvasStyle.height,
    style: canvasStyle
  }, rest));
};

exports.RealtimeChart = RealtimeChart;
RealtimeChart.propTypes = propTypes;
RealtimeChart.defaultProps = defaultProps;