"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SelectionBox = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styles = require("@material-ui/core/styles");

var _core = require("@material-ui/core");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var styles = function styles() {
  return {
    select: {
      minWidth: 180
    }
  };
};

function SelectionBoxC(_ref) {
  var classes = _ref.classes,
      label = _ref.label,
      className = _ref.className,
      data = _ref.data,
      map = _ref.map,
      strings = _ref.strings,
      onChange = _ref.onChange,
      rest = _objectWithoutProperties(_ref, ["classes", "label", "className", "data", "map", "strings", "onChange"]);

  var _useState = (0, _react.useState)([]),
      _useState2 = _slicedToArray(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1];

  (0, _react.useEffect)(function () {
    if (rest.value && rest.value !== value) setValue(rest.value);
  }, [rest.value]);

  var hChange = function hChange(e) {
    setValue(e.target.value);
    if (onChange) onChange(e, e.target.value);
  };

  return _react["default"].createElement(_core.FormControl, {
    className: className
  }, label && _react["default"].createElement(_core.InputLabel, {
    htmlFor: "selector"
  }, label), _react["default"].createElement(_core.Select, _extends({
    onChange: hChange,
    className: classes.select,
    input: _react["default"].createElement(_core.Input, {
      name: "thing",
      id: "selector"
    }),
    value: value
  }, rest), data.map(function (entry) {
    var info = entry;

    if (strings) {
      info = {
        value: entry.toString(),
        label: entry.toString()
      };
    } else if (typeof map === 'function') {
      info = map(info);
    } else if (_typeof(map) === 'object') {
      if (map.value) {
        info = {
          value: info[map.value],
          label: info[map.label || map.value]
        };
      } else {
        info = {
          value: entry.toString(),
          label: entry.toString()
        };
      }
    }

    return _react["default"].createElement(_core.MenuItem, {
      key: info.value,
      value: info.value,
      disableRipple: true
    }, info.label);
  })));
}

SelectionBoxC.propTypes = {
  classes: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired,
  label: _propTypes["default"].string,
  className: _propTypes["default"].string,
  data: _propTypes["default"].arrayOf(_propTypes["default"].any).isRequired,
  map: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].objectOf(_propTypes["default"].any)]),
  strings: _propTypes["default"].bool,
  onChange: _propTypes["default"].func
};
SelectionBoxC.defaultProps = {
  label: undefined,
  onChange: undefined,
  map: undefined,
  strings: false,
  className: undefined
};
var SelectionBox = (0, _styles.withStyles)(styles)(SelectionBoxC);
exports.SelectionBox = SelectionBox;