"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ThresholdGaugeTS = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styles = require("@material-ui/core/styles");

var _Tooltip = _interopRequireDefault(require("@material-ui/core/Tooltip"));

var _get = _interopRequireDefault(require("lodash/fp/get"));

var _formatDistance = _interopRequireDefault(require("date-fns/fp/formatDistance"));

var _Caption = require("./Caption");

var _ThresholdGauge = require("./ThresholdGauge");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var styles = function styles() {
  return {
    flexbox: {
      textAlign: 'center'
    }
  };
};

var hoc = (0, _styles.withStyles)(styles);
var propTypes = {
  msg: _propTypes["default"].objectOf(_propTypes["default"].any),
  classes: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired,
  style: _propTypes["default"].objectOf(_propTypes["default"].any),
  path: _propTypes["default"].string
};
var defaultProps = {
  path: '',
  msg: {},
  style: {}
};

var ThresholdGaugeTSC = function ThresholdGaugeTSC(_ref) {
  var classes = _ref.classes,
      msg = _ref.msg,
      path = _ref.path,
      style = _ref.style,
      rest = _objectWithoutProperties(_ref, ["classes", "msg", "path", "style"]);

  var currentDate = new Date();

  var timeLabel = _react["default"].createElement(_Caption.Caption, {
    label: "Data age: ".concat(msg.ts ? (0, _formatDistance["default"])(currentDate)(msg.ts) : '-')
  });

  return _react["default"].createElement("div", {
    style: _objectSpread({
      justifyContent: 'center',
      display: 'flex',
      flexDirection: 'column'
    }, style)
  }, _react["default"].createElement(_ThresholdGauge.ThresholdGauge, _extends({
    value: (0, _get["default"])(path, msg)
  }, rest)), _react["default"].createElement("div", {
    className: classes.flexbox
  }, msg.ts ? _react["default"].createElement(_Tooltip["default"], {
    title: msg.ts.toISOString()
  }, _react["default"].createElement("span", null, timeLabel)) : timeLabel));
};

ThresholdGaugeTSC.propTypes = propTypes;
ThresholdGaugeTSC.defaultProps = defaultProps;
var ThresholdGaugeTS = hoc(ThresholdGaugeTSC);
exports.ThresholdGaugeTS = ThresholdGaugeTS;